=begin
### (c) TIG 2010
Usage:
  Works on a Selection or if there is none then the Model Entities.
  Type into Ruby Console + <Enter>:
    findtext 'text'
  OR
    findtext 'text', true
  IF ANY 2nd argument REGEX wildcard matching applies, as follows:
ABC matches ABCDEF & XYZABCDEF, but not 123AB-CDEF
^  beginning of a line or string 	e.g. ^A matches ABC not BAC
$  end of a line or string  		e.g. A$ matches CBA not BAC
.  any character (except newline) 	e.g. A.C matches ABC not ACC
[ ] any single character of the set	e.g. [A-Zb-z] matches AbZ not ab9
  also
*  0 or more previous regular expression
*? 0 or more previous regular expression(non-greedy)
? 0 or 1 previous regular expression
+  1 or more previous regular expression
+? 1 or more previous regular expression(non-greedy)
| alternation =
\w any character ==[0-9A-Za-z_]
\W non-word character
\s whitespace character[\t\n\r\f] - tab/newline/return/formfeed
\S non-whitespace character
\d digit ==[0-9]
\D non-digit
\A beginning of a string
\Z end of a string, or before newline at the end
\z end of a string
\b word boundary (outside[ ]only)
\B non-word boundary
\b backspace(0x08) (inside[ ]only)
{m,n}  at least m, but most n previous regular expression
{m,n}? at least m, but most n previous regular expression(non-greedy)
............ see full Ruby Regex for more examples.....
###
Version:
1.1 20100422 Regex 'matching' added.
###
=end
###
require 'sketchup.rb'
###
def findtext(text=nil,regex=false)
  ###
  if not text
    puts "Usage:  findtext('text'), regex=true/false"
	return nil
  end#if
  model=Sketchup.active_model
  ss=model.selection
  ssa=ss.to_a
  tsa=[]
  isa=[]
  if ssa[0]
    ssa.each{|ee|
	  tsa<< ee if ee.class==Sketchup::Text and regex and ee.text=~/#{text}/
	  tsa<< ee if ee.class==Sketchup::Text and not regex and ee.text==text
	  if ee.class==Sketchup::ComponentInstance
	    ee.definition.entities.to_a.each{|e|
		  isa<< ee.definition.instances if e.class==Sketchup::Text and regex and e.text=~/#{text}/
		  isa<< ee.definition.instances if e.class==Sketchup::Text and not regex and e.text==text
        }
	  end#if
	}
  else
	model.entities.each{|e|
	  tsa<< e if e.class==Sketchup::Text and regex and e.text=~/#{text}/
	  tsa<< e if e.class==Sketchup::Text and not regex and e.text==text
	}
	model.definitions.each{|d|
	  d.entities.to_a.each{|e|
	    isa<< e.definition.instances if e.class==Sketchup::Text and regex and e.text=~/#{text}/
		isa<< e.definition.instances if e.class==Sketchup::Text and not regex and e.text==text
	  }
	}
  end#if
  ### now highlight found text/instances
  if ssa[0]
	puts "In the Selection "
  else
	puts "In the Model "
  end#if
  if tsa[0] or isa[0]
    ss.clear
    tsa.each{|e|ss.add(e)}
	isa.each{|a|a.each{|e|ss.add(e)}}
	tct=tsa.length.to_s
	ict=isa.flatten.length.to_s
	Sketchup.send_action("viewZoomToSelection:")
	puts tct+" Text match '"+text+"'"
	puts ict+" Instance Text match '"+text+"'"

  else
    puts "NO match for '"+text+"' found."
  end#if
  puts "as a /REGEX/" if regex
  ###
end#def
